View Issue Details

IDProjectCategoryView StatusLast Update
0006485GNUnetGNSpublic2020-11-14 09:57
Reporterschanzen Assigned Toschanzen  
PrioritynormalSeverityfeatureReproducibilityalways
Status closedResolutionfixed 
Product VersionGit master 
Target Version0.14.0Fixed in Version0.14.0 
Summary0006485: GNS crypto agility
DescriptionWe should make the GNS crypto agile against the zone key.
Currently, we use a "PKEY" record type which is defined as an ECDSA public key that corresponds to the ECDSA private key of the zone.

The GNS crypto uses hierarchical deterministic key derivation (HDKD) to derive zone signing keys from the label and the private key.
Similarly, public keys are derived for signature verification.

Aside from ECDSA, other schemes have been proposed which could be used such as:

Tor-approach: https://gitweb.torproject.org/torspec.git/tree/proposals/224-rend-spec-ng.txt#n2135
BIP32-Ed25519 (Blockchain wallet-approach): https://ieeexplore.ieee.org/document/7966967
Jeff Burdgess-approach: https://github.com/w3f/hd-ed25519

GNS should allow other delegation record types (e.g. "PKEY2") for other schemes.
For this, we need to change wire formats to accomodate crypto agility (different types of zone keys).
Tagslsd0001

Relationships

related to 0006486 assignedschanzen Implement another GNS crypto scheme 

Activities

schanzen

2020-10-28 13:08

manager   ~0017044

Implemented and documented as part of LSD0001

schanzen

2020-11-14 09:57

manager   ~0017139

0.14.0 released

Issue History

Date Modified Username Field Change
2020-08-15 10:35 schanzen New Issue
2020-08-15 10:35 schanzen Status new => assigned
2020-08-15 10:35 schanzen Assigned To => schanzen
2020-08-15 10:35 schanzen Tag Attached: lsd0001
2020-08-15 11:04 schanzen Relationship added related to 0006486
2020-10-28 13:08 schanzen Status assigned => resolved
2020-10-28 13:08 schanzen Resolution open => fixed
2020-10-28 13:08 schanzen Fixed in Version => 0.14.0
2020-10-28 13:08 schanzen Note Added: 0017044
2020-11-14 09:57 schanzen Note Added: 0017139
2020-11-14 09:57 schanzen Status resolved => closed